<?php
/*
Plugin Name: AskApache Google 404
Plugin URI: http://www.askapache.com/seo/404-google-wordpress-plugin.html
Description: Adds Intelligent SEO Ajax-powered Google Search to 404 pages.  <a href="options-general.php?page=aa-google-404.php">Options configuration panel</a>
Version: 3.0
Author: AskApache
Author URI: http://www.askapache.com
*/

/*
== Installation ==

1. Upload aa-google-404.zip to the /wp-content/plugins/ directory
2. Unzip into its own folder /wp-content/plugins/aa-google-404/aa-google-404.php
3. Activate the plugin through the 'Plugins' menu in WordPress by clicking "AskApache Google 404"
4. Go to your Options Panel and open the "AskApache Google 404" submenu. /wp-admin/options-general.php?page=aa-google-404.php
5. Enter in your google Ajax API Key and hit "Update" Button.
6. Add the code to your 404.php template page by including <?php if(function_exists('aa_google_404'))aa_google_404();?> in your main content area.
*/


/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Google 404 Plugin - Adds Ajax Powered Search to 404 Page |
| Copyright (C) 2007, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |   
|                                                                    |
\--------------------------------------------------------------------/
*/

$aa_num_keywords_allowed=6;

$aa_disallowed_words=array('about','after','ago','all','almost','along','alot','also','and','answer','any','anybody','anybodys','anywhere','are','arent','around','askd','because','been','before','being','best','better','between','big','btw','but','can','come','could','couldnt','did','didnt','does','doesnt','dont','etc','either','ever','everybody','everybodys','everyone','far','for','found','game','going','good','got','gotten','had','has','have','havent','having','her','here','hers','him','his','how','hows','ive','isnt','its','just','know','large','less','like','liked','little','looking','look','looked','looking','lot','maybe','many','more','most','much','must','mustnt','near','need','never','new','news','none','not','nothing','now','off','often','old','once','only','oops','other','our','ours','out','over','please','put','question','questions','questioned','quote','rather','really','recent','said','saw','say','says','she','see','sees','should','small','some','something','sometime','somewhere','soon','take','than','thank','that','thatd','thats','the','their','theirs','theres','theirs','them','then','there','these','they','theyll','theyd','theyre','this','those','though','through','thus','too','under','until','untrue','upon','very','via','want','was','way','well','went','were','werent','what','when','where','which','whom','whose','why','wide','will','with','within','without','wont','world','worse','worst','would','wrote','yes','yet','you','youd','youll','your','youre','yours');



// aa_google_404_options_setup
//---------------------------
function aa_google_404_options_setup() {
	global $aa_G404;
    add_options_page($aa_G404['Name'], 'AA Google 404', 8, basename(__FILE__), 'aa_google_404_page');
}//=====================================================================================




// aa_google_404
//---------------------------
function aa_google_404(){
    if(is_404()){
    	$aa_google_404_code_html = get_option('aa_google_404_code_html');
		echo $aa_google_404_code_html;
    }
}//=====================================================================================




// aa_google_404_page
//---------------------------
function aa_google_404_page() {
    global $aa_G404,$aa_google_404_api_key,$aa_google_404_code_js,$aa_google_404_code_css,$aa_google_404_code_html,$aa_status;
    
    if ( function_exists('current_user_can') && !current_user_can('manage_options') ) die(__('Cheatin&#8217; uh?'));
    if (! user_can_access_admin_page()) wp_die( __('You do not have sufficient permissions to access this page.') );


	$aa_template_404=TEMPLATEPATH.'/404.php';
	$aa_google_404_template_404=dirname(__FILE__).'/404.php';
	if(!file_exists($aa_template_404)){
		if (!copy($aa_google_404_template_404,$aa_template_404))$aa_status.='<div id="message" class="error fade"><p><strong>ERROR:</strong>404.php file not found.. attempting to create.. FAILED!</p></div>';
		else $aa_status=$aa_status.='<div id="message" class="updated fade"><p><strong>Message:</strong>404.php file not found.. attempting to create.. SUCCESS!</p></div>';
	}

	
    $aa_head='<p style="text-align:center;">[  <a href="http://www.askapache.com/seo/tip-google-analytics-404-error-page.html">404 Error Page tip for Google Analytics</a> - Home: '.$aa_G404['Title'].' - Version: <strong>'.$aa_G404['Version'].'</strong> - Author: '.$aa_G404['Author'].' ]</p><hr style="visibility:hidden;">';
    $aa_test='<div class="wrap" style="height:175px;overflow:auto;">'.$aa_google_404_code_html.'</div>';
    $aa_main ='<div class="wrap"><h2>'.$aa_G404['Name'].'</h2><a href="/404/test-404-page-plugin-askapache-wordpress-plugin-search-engine.html">Test Your 404 Page</a>';
    
    _e($aa_head);
    _e($aa_status);
    _e($aa_test);
    _e($aa_main);
	aa_print_google_404_form();
	aa_print_google_links();
    
}//=====================================================================================



// aa_google_404_admin_header
//---------------------------
function aa_google_404_admin_header(){
    global $aa_G404,$aa_google_404_api_key,$aa_google_404_code_js,$aa_google_404_code_css,$aa_google_404_code_html,$aa_status;
	$aa_G404=get_plugin_data(__FILE__);

    if($_SERVER['REQUEST_METHOD']==='POST'){
        $valid_nonce = wp_verify_nonce($_REQUEST['_wpnonce'], 'aa-google-404-update_modify');
        if(isset($_POST['aagooglecodejs'])) 	update_option('aa_google_404_code_js',stripslashes($_POST['aagooglecodejs']));
        if(isset($_POST['aagooglecodehtml'])) 	update_option('aa_google_404_code_html',stripslashes($_POST['aagooglecodehtml']));
        if(isset($_POST['aagooglecodecss'])) 	update_option('aa_google_404_code_css',stripslashes($_POST['aagooglecodecss']));
        if(isset($_POST['aagoogleapikey'])) 	update_option('aa_google_404_api_key',$_POST['aagoogleapikey']);
    	$aa_google_404_code_html = get_option('aa_google_404_code_html');
    	$aa_google_404_code_js = get_option('aa_google_404_code_js');
    	$aa_google_404_code_css = get_option('aa_google_404_code_css');
    	$aa_google_404_api_key = get_option('aa_google_404_api_key');
		
		
        $aa_status = '<div id="message" class="updated fade"><p><strong>Successfully Updated Code</strong>.</p></div>';
		if(isset($_POST['aaresetgooglecode'])) {
			aa_google_404_activate();
	        $aa_status = '<div id="message" class="updated fade"><p><strong>Successfully Reset Plugin Options</strong>.</p></div>';
		}
    }
	
	if(strpos($aa_google_404_api_key, 'askapache')!==false){
		$aa_status = '<div id="message" class="error fade"><p><strong>Warning:</strong> You need to <a href="http://code.google.com/apis/ajaxsearch/signup.html">get a free Google API Key</a> before this plugin will fully work.</p></div>';
	}
	
    
    	$aa_google_404_code_html = get_option('aa_google_404_code_html');
    	$aa_google_404_code_js = get_option('aa_google_404_code_js');
    	$aa_google_404_code_css = get_option('aa_google_404_code_css');
    	$aa_google_404_api_key = get_option('aa_google_404_api_key');
		
    	$aa_label='+askapache';
    	$aa_execute=aa_get_keywords('|');
        $aa_mysite=str_replace('www.','',$_SERVER['HTTP_HOST']);	
		
		echo "\n\n".'<!-- Google 404 Plugin by AskApache.com -->'."\n";
    	echo '<script language="Javascript" type="text/javascript">'."\n".'<!--//'."\n".
    	'aalabel="'.$aa_label.'";aamysite="'.$aa_mysite.'";aaexecute="'.$aa_execute.'";'."\n".'//-->'."\n".'</script>';

    	echo "\n".'<script src="http://www.google.com/jsapi?key='.$aa_google_404_api_key.'" type="text/javascript"></script>'."\n";
    	echo $aa_google_404_code_js;
    	echo $aa_google_404_code_css;
		echo "\n".'<!-- Google 404 Plugin by AskApache.com -->'."\n\n";
    
}//=====================================================================================



// aa_google_404_header
//---------------------------
function aa_google_404_header(){
    global $aa_google_404_api_key,$aa_google_404_code_js,$aa_google_404_code_css,$aa_google_404_code_html;
    
    if(is_404())
    {
    	$aa_google_404_code_html = get_option('aa_google_404_code_html');
    	$aa_google_404_code_js = get_option('aa_google_404_code_js');
    	$aa_google_404_code_css = get_option('aa_google_404_code_css');
    	$aa_google_404_api_key = get_option('aa_google_404_api_key');
		$aa_google_404_api_key=str_replace('-askapache','',$aa_google_404_api_key);
		
    	$aa_label=get_option('blogname');
    	$aa_execute=aa_get_keywords('|');
        $aa_mysite=str_replace('www.','',$_SERVER['HTTP_HOST']);	
		
		echo "\n\n".'<!-- Google 404 Plugin by AskApache.com -->'."\n";
    	echo '<script language="Javascript" type="text/javascript">'."\n".'<!--//'."\n".
    	'aalabel="'.$aa_label.'";aamysite="'.$aa_mysite.'";aaexecute="'.$aa_execute.'";'."\n".'//-->'."\n".'</script>';

    	echo "\n".'<script src="http://www.google.com/jsapi?key='.$aa_google_404_api_key.'" type="text/javascript"></script>'."\n";
    	echo $aa_google_404_code_js;
    	echo $aa_google_404_code_css;
		echo "\n".'<!-- Google 404 Plugin by AskApache.com -->'."\n\n";
	}
}//=====================================================================================





// aa_print_google_404_form
//---------------------------
function aa_print_google_404_form(){
    global $aa_google_404_api_key,$aa_google_404_code_js,$aa_google_404_code_css,$aa_google_404_code_html;

    echo '<hr style="visibility:hidden;"><form name="aa_404_form" action="'. $_SERVER["REQUEST_URI"] . '" method="post">';
    echo '<label for="aagoogleapikey">Google API Key</label><br />';
    echo '<input tabindex=1" size="91" type="text" name="aagoogleapikey" value="'.$aa_google_404_api_key.'" />';
    echo '<br style="clear:both;" />';

    echo '<hr style="visibility:hidden;">';
    echo '<label for="aagooglecodehtml">XHTML Code</label><br />';
    echo '<textarea cols="90" rows="3" name="aagooglecodehtml" id="aagooglecodehtml">'.$aa_google_404_code_html.'</textarea>';
    echo '<br style="clear:both;" />';

    echo '<hr style="visibility:hidden;">';
    echo '<label for="aagooglecodecss">CSS Code</label><br />';
    echo '<textarea cols="90" rows="7" name="aagooglecodecss" id="aagooglecodecss">'.$aa_google_404_code_css.'</textarea>';
    echo '<br style="clear:both;" />';

    echo '<hr style="visibility:hidden;">';
    echo '<label for="aagooglecodejs">JavaScript Code</label><br />';
    echo '<textarea cols="90" rows="9" name="aagooglecodejs" id="aagooglecodejs">'.$aa_google_404_code_js.'</textarea>';
    echo '<br style="clear:both;" />';
    echo '<hr style="visibility:hidden;">';
    echo '<div class="submit"><input type="submit" name="updateaagooglecode" id="updateaagooglecode" value="Update Code" class="button" style="float:left;margin-right:2em;" /><input type="submit" name="aaresetgooglecode" id="aaresetgooglecode" value="Reset To Defaults" class="button" style="float:left;" /><br style="clear:both;" /></div>';
    wp_nonce_field('aa-google-404-update_modify');
	echo '</form></div>';
	
}//=====================================================================================







// aa_print_google_links
//---------------------------
function aa_print_google_links(){
// Thanks Google, you Rock from the Start!
echo '<div style="width:400px;margin:20px auto;">
<h3>More Info from Google</h3>
<ul>
<li><a href="http://code.google.com/apis/ajaxsearch/">AJAX Search API</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/signup.html">Start Using the API</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/wizards.html">AJAX Search Wizards</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/documentation/">Developer Guide</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/documentation/reference.html">Class Reference</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/samples.html">Code Samples</a></li>
<li><a href="http://code.google.com/apis/ajaxsearch/community-samples.html">Community Samples</a></li>
<li><a href="http://code.google.com/support/bin/topic.py?topic=10021">Knowledge Base</a></li>
<li><a href="http://googleajaxsearchapi.blogspot.com/">AJAX APIs Blog</a></li>
<li><a href="http://groups.google.com/group/Google-AJAX-Search-API">Developer Forum</a></li>
</ul>
<hr style="visibility:hidden;" />
<hr style="visibility:hidden;" /></div>';
}//=====================================================================================


// aa_get_keywords
//---------------------------
function aa_get_keywords($sep){
	global $aa_num_keywords_allowed,$aa_disallowed_words;

	$aa_matched_keywords=array();
	$url=strtolower(html_entity_decode(strip_tags($_SERVER['REQUEST_URI'])));
	$t=preg_match_all("/[\w]{3,15}/", $url, $aa_matched_keywords);
	
	foreach ($aa_matched_keywords[0] as $key => $aa_word){
		if(!in_array($aa_word,$aa_disallowed_words))$aa_computed_searchwords[]=$aa_word;
	}
	
	$aa_computed_searchwords = array_unique($aa_computed_searchwords);
	if(sizeof($aa_computed_searchwords)>$aa_num_keywords_allowed) array_splice($aa_computed_searchwords, $aa_num_keywords_allowed+1);

	$aa_computed_searchwords = implode($sep, $aa_computed_searchwords);
	
	return trim($aa_computed_searchwords);
}//=====================================================================================





// aa_google_404_deactivate
//---------------------------
function aa_google_404_deactivate(){
	delete_option('aa_google_404_url');
    delete_option('aa_google_404_code_html');
    delete_option('aa_google_404_code_js');
    delete_option('aa_google_404_code_css');
    delete_option('aa_google_404_api_key');
}//=====================================================================================



// aa_google_404_activate
//---------------------------
function aa_google_404_activate(){
	global $aa_G404;
	$aa_G404=get_plugin_data(__FILE__);
	
	
	$aa_google_404_url = get_option('siteurl').'/wp-content/plugins/'.basename(__FILE__,'.php');
	
	//. . trailingslashit(substr($path,strpos($path,"wp-content/")));

   $aa_google_404_api_key='ABQIAAAAulvh3KQawKQWxn64grPVShSrXMCP0pDj9HHVk8NG53Pp2_-7KxQrSRl65MAnUMDqm9AubaFv5BYXEg-askapache';

	$aa_google_404_code_html='<div id="askapache404">'."\n".'<span class="askapache">Wait a sec, I might be able to help...</span>'."\n".'<hr class="C" />'."\n".'</div>'."\n";

	
	$aa_google_404_code_css=
    "\n".'<style type="text/css">
#askapache404 {margin:20px auto;width:99%;vertical-align:top;}
.askapache {font-weight:bold; line-height:50px; padding:0 33px 0 0; background:url('.$aa_google_404_url.'/askapache-404.gif'.') center right no-repeat; overflow:hidden; cursor:wait;}
.gsc-control {width:100%;margin:0 auto;position:relative;overflow:hidden;}
.gsc-control form {width:96%;}
.gsc-control table {margin:0;padding:0;}
.gsc-control, .gsc-control * {font-family:"trebuchet ms",verdana,sans-serif;font-size:13px;}
.askapache td,.askapache th {border-color:#FFF;}
</style>'."\n";

    $aa_google_404_code_js=
'<script language="Javascript" type="text/javascript">
//<![CDATA[
google.load("search", "1");
function OnLoad() {
var rightScDiv = document.getElementById("askapache404");
this.rightControl = new GSearchControl();
this.rightControl.setResultSetSize(GSearch.LARGE_RESULTSET);
this.rightControl.setLinkTarget(GSearch.LINK_TARGET_SELF);
var options;
options = new GdrawOptions();
options.setDrawMode(GSearchControl.DRAW_MODE_TABBED);
var mySiteSearch = new GwebSearch();
mySiteSearch.setUserDefinedLabel(aamysite);
mySiteSearch.setSiteRestriction(aamysite);
var myWebSearch = new GwebSearch();
myWebSearch.setQueryAddition(aalabel);
var myBlogSearch = new GblogSearch();
myBlogSearch.setQueryAddition(aalabel);
var myVideoSearch = new GvideoSearch();
myVideoSearch.setQueryAddition(aalabel);
var myCseSearch = new GwebSearch();
myCseSearch.setUserDefinedLabel("CSE");
myCseSearch.setSiteRestriction("002660089121042511758:kk7rwc2gx0i");
myCseSearch.setQueryAddition("'.strtolower(strip_tags($aa_G404['Author'])).'");
var myImageSearch = new GimageSearch();
myImageSearch.setQueryAddition(aalabel);
this.rightControl.addSearcher(mySiteSearch);
this.rightControl.addSearcher(myWebSearch);
this.rightControl.addSearcher(myBlogSearch);
this.rightControl.addSearcher(myVideoSearch);
this.rightControl.addSearcher(myImageSearch);
this.rightControl.addSearcher(myCseSearch);
options.setDrawMode(GSearchControl.DRAW_MODE_TABBED);
this.rightControl.draw(rightScDiv, options);
this.rightControl.execute(aaexecute);
}
google.setOnLoadCallback(OnLoad);
//]]>
</script>';
	
    

	update_option('aa_google_404_url',$aa_google_404_url);
    update_option('aa_google_404_api_key',$aa_google_404_api_key);
    update_option('aa_google_404_code_html',stripslashes($aa_google_404_code_html));
    update_option('aa_google_404_code_js',stripslashes($aa_google_404_code_js));
    update_option('aa_google_404_code_css',stripslashes($aa_google_404_code_css));
}//=====================================================================================



add_action('admin_menu', 'aa_google_404_options_setup');
if(false!==($aa_goadm=strpos($_SERVER['REQUEST_URI'], basename(__FILE__))))add_action('admin_head', 'aa_google_404_admin_header');
add_action('wp_head', 'aa_google_404_header');

register_deactivation_hook(__FILE__, 'aa_google_404_deactivate');
register_activation_hook(__FILE__, 'aa_google_404_activate');
?>